/*
 * Definitions for libfshfs
 *
 * Copyright (C) 2009-2018, Joachim Metz <joachim.metz@gmail.com>
 *
 * Refer to AUTHORS for acknowledgements.
 *
 * This software is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this software.  If not, see <http://www.gnu.org/licenses/>.
 */

#if !defined( _LIBFSHFS_DEFINITIONS_H )
#define _LIBFSHFS_DEFINITIONS_H

#include <libfshfs/types.h>

#define LIBFSHFS_VERSION		20180927

/* The version string
 */
#define LIBFSHFS_VERSION_STRING		"20180927"

/* The file access
 * bit 1        set to 1 for read access
 * bit 2        set to 1 for write access
 * bit 3-8      not used
 */
enum LIBFSHFS_ACCESS_FLAGS
{
	LIBFSHFS_ACCESS_FLAG_READ	= 0x01,
/* Reserved: not supported yet */
	LIBFSHFS_ACCESS_FLAG_WRITE	= 0x02
};

/* The file access macros
 */
#define LIBFSHFS_OPEN_READ		( LIBFSHFS_ACCESS_FLAG_READ )
/* Reserved: not supported yet */
#define LIBFSHFS_OPEN_WRITE		( LIBFSHFS_ACCESS_FLAG_WRITE )
/* Reserved: not supported yet */
#define LIBFSHFS_OPEN_READ_WRITE	( LIBFSHFS_ACCESS_FLAG_READ | LIBFSHFS_ACCESS_FLAG_WRITE )

/* The path segment separator
 */
#define LIBFSHFS_SEPARATOR		'/'

/* The file system types
 */
enum LIBFSHFS_FILE_SYSTEM_TYPES
{
        LIBFSHFS_EXTENT_FILE_SYSTEM_TYPE_UNDEFINED,
        LIBFSHFS_EXTENT_FILE_SYSTEM_TYPE_HFS,
        LIBFSHFS_EXTENT_FILE_SYSTEM_TYPE_HFS_PLUS,
        LIBFSHFS_EXTENT_FILE_SYSTEM_TYPE_HFSX
};

#endif /* !defined( _LIBFSHFS_DEFINITIONS_H ) */

